//
//  ComAgilentLibintunemsalProxy.swift
//  LibIntuneMSAL
//
//  Created by Your Name
//  Copyright (c) 2019 Your Company. All rights reserved.
//

import UIKit
import TitaniumKit
import MSAL




@objc(ComAgilentLibintunemsalProxy)
class ComAgilentLibintunemsalProxy: TiProxy {

  override func _init(withPageContext context: TiEvaluator!) -> Self? {
    super._init(withPageContext: context)

    // Custom proxy init
    
    return self
  }
  
    let fusionURL = "https://testurl"
    let peopleURL = "https://testurl"
      
      //let kScopes: [String] = ["https://graph.microsoft.com/user.read"]
      let kFusionScope: [String] =  ["https://testurl"]
      let kScopes: [String] = ["https://testurl"]
      
      let kClientID = "xxxxxx"
      let kAuthority = "yyyyyyyy" // directory id
      
      var accessToken = String()
      var applicationContext : MSALPublicClientApplication?
      var webViewParamaters : MSALWebviewParameters?
    
    
    
    @objc(initiateMSALTokenRequest:)
    func initiateMSALTokenRequest(requestParam: NSDictionary?)  {
        
        do {
            
        let requestParamDict = requestParam!
        guard let authorityURL = URL(string: kAuthority) else {
            //self.updateLogging(text: "Unable to create authority URL")
            NSLog("Unable to create authority URL")
            return
        }
        
        let authority = try MSALAADAuthority(url: authorityURL)
        
        let msalConfiguration = MSALPublicClientApplicationConfig(clientId: kClientID, redirectUri: nil, authority: authority)
        self.applicationContext = try MSALPublicClientApplication(configuration: msalConfiguration)
        
            self.webViewParamaters = MSALWebviewParameters(parentViewController: requestParamDict.object(forKey: "VC") as! TiViewController)
            //TODO: this need to provided the view controller object detail
            
            
            guard let currentAccount = self.currentAccount() else {
                       // We check to see if we have a current logged in account.
                       // If we don't, then we need to sign someone in.
                       acquireTokenInteractively()
                       return
                   }
                   
                   acquireTokenSilently(currentAccount)
            
        }
        catch let error as NSError {
         NSLog("Error while initlaite the Token Request")
        }
    }
    
//    func initWebViewParams() {
//           self.webViewParamaters = MSALWebviewParameters(parentViewController: requestParamDict.object(forKey: "VC") as! TiViewController)
//        
//        //TODO: this need to provided the view controller object detail
//    }
    
    //@objc(acquireTokenInteractively:)
    func acquireTokenInteractively() {
        guard let applicationContext = self.applicationContext else { return }
        guard let webViewParameters = self.webViewParamaters else { return }

        let parameters = MSALInteractiveTokenParameters(scopes: kScopes, webviewParameters: webViewParameters)
        parameters.promptType = .selectAccount;
        
        applicationContext.acquireToken(with: parameters) { (result, error) in
            
            if let error = error {
                NSLog("Could not acquire token: ")
                return
            }
            
            guard let result = result else {
                
                NSLog("Could not acquire token: No result returned")
                return
            }
            
            self.accessToken = result.accessToken
            NSLog("Access Token %@", self.accessToken)
            //self.updateSignOutButton(enabled: true)
        }
    }
    
    //@objc(acquireTokenSilently:)
    func acquireTokenSilently(_ account : MSALAccount!) {
            
            guard let applicationContext = self.applicationContext else { return }
            
            /**
             
             Acquire a token for an existing account silently
             
             - forScopes:           Permissions you want included in the access token received
             in the result in the completionBlock. Not all scopes are
             guaranteed to be included in the access token returned.
             - account:             An account object that we retrieved from the application object before that the
             authentication flow will be locked down to.
             - completionBlock:     The completion block that will be called when the authentication
             flow completes, or encounters an error.
             */
            
            let parameters = MSALSilentTokenParameters(scopes: kScopes, account: account)
            
            applicationContext.acquireTokenSilent(with: parameters) { (result, error) in
                
                if let error = error {
                    
                    let nsError = error as NSError
                    
                    // interactionRequired means we need to ask the user to sign-in. This usually happens
                    // when the user's Refresh Token is expired or if the user has changed their password
                    // among other possible reasons.
                    
                    if (nsError.domain == MSALErrorDomain) {
                        
                        if (nsError.code == MSALError.interactionRequired.rawValue) {
                            
                            DispatchQueue.main.async {
                                self.acquireTokenInteractively()
                            }
                            return
                        }
                    }
                    
//                    self.updateLogging(text: "Could not acquire token silently: \(error)")
                    NSLog("Could not acquire token silently")
                    return
                }
                
                guard let result = result else {
                    
                    NSLog("Could not acquire token: No result returned")
                    return
                }
                
                self.accessToken = result.accessToken
                NSLog("Refresh Access token is %@", self.accessToken)
                //self.updateSignOutButton(enabled: true)
                
                //self.callHanaWS();
    //
            }
        }
    
    func currentAccount() -> MSALAccount? {
        
        guard let applicationContext = self.applicationContext else { return nil }
        
        // We retrieve our current account by getting the first account from cache
        // In multi-account applications, account should be retrieved by home account identifier or username instead
        do {
            
            let cachedAccounts = try applicationContext.allAccounts()
            
            if !cachedAccounts.isEmpty {
                return cachedAccounts.first
            }
            
        } catch let error as NSError {
            
            NSLog("Didn't find any accounts in cache: %@", error)
        }
        
        return nil
    }
}
